<template>
    <v-app id="inspire">
        <slot name="drawer">
        <sidebar></sidebar>
    </slot>
        <slot name="nav">
            <navigation></navigation>
        </slot>

        <v-content>
            <v-container fluid justify-center align-center fill-height>
                <v-layout row justify-center align-center fill-height>
                    <slot name="main">
                        <v-flex xs4>
                            <TreeMenu v-for="(route, index) in nav.children" :index=index :icon="route.icon" :children="route.children" :path="route.path" :name="route.name" :depth="index" value="false"
                                      :navigation="route.navigation"></TreeMenu>
                        </v-flex>
                    </slot>
                </v-layout>
            </v-container>
        </v-content>

        <v-footer app>
            <v-flex xs2 text-xs-center>
                <span>Apiplaform & Vuetify</span>
            </v-flex>
            <v-flex xs8>
                <v-breadcrumbs class="dark--text" :exact="true" :dark=dark :items="breadCrumbs" :divider="divider"></v-breadcrumbs>
            </v-flex>
            <v-flex xs2 text-xs-center>
                <span>&copy; 2017 - VueJSapp</span>
            </v-flex>
        </v-footer>
    </v-app>
</template>

<script>
    import Navigation from "../components/Navigation";
    import ErrorBoundary from "../components/ErrorBoundary";
    import Sidebar from "../components/Sidebar";
    import LoginForm from "../components/form/LoginForm";
    import TreeMenu from "../components/TreeMenu";

    export default {
        name: "BasePageVuetify",
        components: {
            TreeMenu,
            'sidebar': Sidebar,
            'navigation': Navigation,
            'error-boundary': ErrorBoundary,
            'login-form': LoginForm
        },
        computed: {
            breadCrumbs: function () {
                let pathArray = this.$route.path.split("/");
                let matchedRoutes = this.$route.matched;

                pathArray[0]='/';

                let breadcrumbs = pathArray.reduce((breadcrumbArray, path, idx) => {
                    if(idx >= matchedRoutes.length) return breadcrumbArray;
                    breadcrumbArray.push({
                        to: idx === matchedRoutes.length-1 ? null : matchedRoutes[idx].path,
                        text: matchedRoutes[idx].name || '/',
                        disabled: false
                    });
                    return breadcrumbArray;
                }, []);
                breadcrumbs.unshift({
                    to: '/',
                    text: 'Home',
                    disabled: true
                })
                return breadcrumbs;
            }
        },
        data: function () {
            return {
                nav: {
                    children: this.$router.options.routes
                },
                drawer: true,
                divider: '>',
                dark: false
            }
        },
        props:
            {}
        ,
        filters: {}
        ,
        mounted() {
        }

    }
</script>

<style lang="stylus" scoped>

    $color-pack = false

    @import '~vuetify/src/stylus/main'
</style>
